<script lang="ts">
// 声明额外的选项
export default {
  name: "PriRecursionStartField"
};
</script>
<script setup lang="ts">
import { provide } from "vue";
import { usePriRecursionStartField } from "./hook";
import { http } from "@/utils/http";
import { useRenderIcon, hasAuth, PureTableBar } from "@/utils/importUsed"
import Add from "./components/add/index.vue";
import EditUpdatePriRecursionStartField from "./components/updatePriRecursionStartField/index.vue";
import Search from "@iconify-icons/ep/search";
import Addicon from "@iconify-icons/ep/document-add";
import Delete from "@iconify-icons/ep/delete";
import EditPen from "@iconify-icons/ep/edit-pen";
import More from "@iconify-icons/ep/more-filled";

const {
  form,
  loading,
  columns,
  dataList,
  pagination,
  onSearch,
  handleSizeChange,
  handleCurrentChange,
  handleSelectionChange,
  ruleFormRef,
  objectTableIdOptionList,
  handleAdd,
  addVisible,
  handleUpdatePriRecursionStartField,
  editUpdatePriRecursionStartFieldVisible,
  editUpdatePriRecursionStartFieldFormData,
  handleDelete,

} = usePriRecursionStartField();
// 关闭添加
const closeAddVisible = () => {
  onSearch(ruleFormRef.value);
  addVisible.value = false;
}
provide('closeAddVisible', closeAddVisible)
// 关闭修改
const closeEditUpdatePriRecursionStartFieldVisible = () => {
  onSearch(ruleFormRef.value);
  editUpdatePriRecursionStartFieldVisible.value = false
}
provide('closeEditUpdatePriRecursionStartFieldVisible', closeEditUpdatePriRecursionStartFieldVisible)

</script>

<template lang="pug">
.main
  div
    //- 搜索表格组件条件
    el-form.bg-bg_color.pl-8.pt-4.pr-8(
      label-position="left"
      label-width="100px"
      :inline="true",
      :model="form",
      class="w-[99/100]"
      ref="ruleFormRef"
      :rules="rules"
    )
      el-form-item(label='字段名称' prop="fieldName")
        el-input(v-model='form.fieldName' autocomplete='off'
          placeholder="请输入字段名称")
      el-form-item(label='字段名' prop="fieldEnName")
        el-input(v-model='form.fieldEnName' autocomplete='off'
          placeholder="请输入字段名")
      el-form-item(label="对象表", prop="objectTableId")
        el-select(
          v-model="form.objectTableId",
          placeholder="请选择对象表",
          clearable,
        )
          el-option(:label="item.tableEnName", :value="item.id" v-for="(item,index) in objectTableIdOptionList")

      el-form-item
        el-button(
          type="primary",
          :icon="useRenderIcon(Search)",
          :loading="loading",
          @click="onSearch(ruleFormRef)"
        ) 查询
    //- 表格组件
    PureTableBar(title="递归开始条件字段", @refresh="onSearch(ruleFormRef)" )
      template(#buttons)
        el-button(type="primary" :icon="useRenderIcon(Addicon)" @click="handleAdd()" v-if="hasAuth(['add'])") 新增

      template(v-slot="{ size, checkList }")
        pure-table( 
          row-key="id"
          ref="tableRef"
          adaptive
          align-whole="center"
          table-layout="auto"
          :loading="loading"
          :size="size",
          :data="dataList",
          :columns="columns",
          :checkList="checkList",
          :pagination="pagination",
          :paginationSmall="size === 'default' ? true : false",
          :header-cell-style="{ background: 'var(--el-table-row-hover-bg-color)', color: 'var(--el-text-color-primary)' }",
          @selection-change="handleSelectionChange",
          @size-change="handleSizeChange",
          @current-change="handleCurrentChange"
        )
          template(#operation="{ row }")
            el-button.reset-margin(
              link
              type="primary"
              size="small"
              @click="handleUpdatePriRecursionStartField(row)"
              :icon="useRenderIcon(EditPen)"
              v-if="hasAuth(['updatePriRecursionStartField'])"
            ) 编辑
            el-button.reset-margin(
              link
              type="primary"
              size="small"
              @click="handleDelete(row)"
              :icon="useRenderIcon(Delete)"
              v-if="hasAuth(['delete'])"
            ) 删除



    Add(:addVisible="addVisible" :objectTableId="form.objectTableId")
    EditUpdatePriRecursionStartField(:editVisible="editUpdatePriRecursionStartFieldVisible" :formData="editUpdatePriRecursionStartFieldFormData")

                    
</template>

<style scoped lang="scss">
:deep(.el-dropdown-menu__item i) {
  margin: 0;
}

:deep(.el-form-item__label) {
  font-weight: 700;
}

:deep(.el-pagination) {
  flex-flow: wrap;
}

:deep(.is-draggable) {
  max-height: 80vh;
  overflow: auto;
}

:deep(.el-dialog__header) {
  position: sticky;
  top: 0;
  z-index: 2;
  background: #fff;
}

:deep(.el-descriptions__header) {
  margin: 16px 0 !important;
}
</style>